/**
 * Draws the "Dragon Curve" fractal image.
 * 
 * @author Claude Sammut 
 * @version 24 July 2012
 */

public class Dragon extends Turtle
{
    final int rightTurn = 90;
    final int leftTurn = -90;
    final int length = 100;

    /**
     * Draw one segment of the dragon curve, recursively
     * 
     * @param  depth   when depth is 1, draw a line, otherwise recurse.
     * @param  turn    90 turns right, -90 turns left
     */
    public void dragonSegment(int depth, int turn)
    {
        if (depth == 0)
            move(length);
        else
        {
            depth--;
            dragonSegment(depth, rightTurn);
            rotate(turn);
            dragonSegment(depth, leftTurn);
        }
    }

    /**
     * Start the dragon curve with the given depth and length
     *
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y
     */
    public void dragonCurve(int depth)
    {
        reset();
        rotate(leftTurn);
        dragonSegment(depth, rightTurn);
    }
}
